#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 5005;
int n, m;
string a[MAXN];
int pref[MAXN][MAXN];

inline bool check_sq(int x, int y, int s) {
	return pref[x + s - 1][y + s - 1]
		   - (x > 0 ? pref[x - 1][y + s - 1] : 0)
		   - (y > 0 ? pref[x + s - 1][y - 1] : 0)
		   + (x > 0 && y > 0 ? pref[x - 1][y - 1] : 0)
		   == s * s;
}

inline bool check(int x, int y, int s) {
	return check_sq(x, y, s) &&
		   check_sq(x + s, y, s) &&
		   check_sq(x - s, y, s) &&
		   check_sq(x, y + s, s) &&
		   check_sq(x, y - s, s);
}

int main() {
#ifdef DEBUG
	freopen("input", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			pref[i][j] = a[i][j] == '#' ? 1 : 0;
			pref[i][j] += i > 0 ? pref[i - 1][j] : 0;
			pref[i][j] += j > 0 ? pref[i][j - 1] : 0;
			pref[i][j] -= i > 0 && j > 0 ? pref[i - 1][j - 1] : 0;
		}
	}

	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		cerr << pref[i][j] << " ";
	// 	}
	// 	cerr << endl;
	// }

	int L = 0;
	int R = MAXN;
	while (R - L > 1) {
		int M = (L + R) / 2;

		bool ok = false;
		for (int i = M; i <= n - 2 * M; i++) {
			for (int j = M; j <= m - 2 * M; j++) {
				if (check(i, j, M)) {
					ok = true;
					break;
				}
			}
			if (ok) {
				break;
			}
		}

		if (ok) {
			L = M;
		} else {
			R = M;
		}
	}

	cout << L << endl;

	return 0;
}