#include "testlib.h"
#include <vector>
#include <iostream>
#include <string>
#include <unordered_set>

using namespace std;


template<typename T>
string to_string(const T& x) 
{
    stringstream ss;
    ss << x;
    return ss.str();
}


template<typename T>
string check(T &ouf, vector<int>& a, int& m, int& k, int& ans) 
{
    ans = ouf.readInt();
    int n = a.size();
    vector<int> was(n, false);
    for (int i = 0; i < ans; i++)
    {
        unordered_set<int> used;
        vector<int> v(k);
        for (int j = 0; j < k; j++) 
        {
            int cur = ouf.readInt();
            if (cur < 1 || cur > n)
                return "Incorrect index " + to_string(j + 1) + " in " + to_string(i + 1) + " line"; 
            cur--;
            if (was[cur])
                return "Already used index " + to_string(j + 1) + " in " + to_string(i + 1) + " line"; 
            if (used.find(a[cur]) != used.end())
                return "Duplicate number " + to_string(j + 1) + " in " + to_string(i + 1) + " line"; 
            used.insert(a[cur]);
            was[cur] = true;
            v[j] = cur;
        }
        int minn = n;
        int maxx = -1;
        for (int j = 0; j < k; j++)
        {
            minn = min(minn, v[j]);
            maxx = max(maxx, v[j]);
        }
        if (maxx - minn > m)
            return "Wrong distance in " + to_string(i + 1) + "line";  
    }
    return "ok";
}

int main(int argc, char* argv[])
{
    registerTestlibCmd(argc, argv);
    
    
    int n = inf.readInt();
    int m = inf.readInt();
    int k = inf.readInt();
    
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        a[i] = inf.readInt();


    int jcnt, ccnt;
    string cans = check(ouf, a, m, k, ccnt);
    string jans = check(ans, a, m, k, jcnt);
    quitif(cans != "ok", _wa, cans.c_str());
    quitif(jans != "ok", _fail, jans.c_str());
    quitif(jcnt > ccnt, _wa, "Not optimal answer %d expected, %d found", jcnt, ccnt);
    quitif(jcnt < ccnt, _fail, "Jury has not optimal answer %d expected, %d found", jcnt, ccnt);
    quitf(_ok, "%d", jcnt);
    return 0;
}