#include <iostream>
#include <algorithm>
#include <utility>
#include <queue>
using namespace std;

const int MAXN = 2000;

int initial_height[MAXN][MAXN];

int n, m;

int dx[4] = {-1, 0, 1, 0};
int dy[4] = {0, 1, 0, -1};

bool inside(int x, int y) {
  return x >= 0 && y >= 0 && x < n && y < m;
}

pair<int, pair<int, int> > sorted_heights[MAXN * MAXN];

bool was[MAXN][MAXN];

int main() {
#ifdef home
  freopen("i", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

  cin >> n >> m;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      cin >> initial_height[i][j];
      sorted_heights[i * m + j] = {initial_height[i][j], {i, j}};
    }
  }

  sort(sorted_heights, sorted_heights + n * m);

  long long ans = 0;

  queue<pair<int, int> > q;

  for (int cur = 0; cur < n * m; cur++) {
    int height = sorted_heights[cur].first;
    int start_i = sorted_heights[cur].second.first;
    int start_j = sorted_heights[cur].second.second;

    bool ok = false;
    for (int k = 0; k < 4; k++) {
      int x = start_i + dx[k];
      int y = start_j + dy[k];
      if (!inside(x, y) || was[x][y]) {
        ok = true;
      }
    }
    if (!ok) {
      continue;
    }
    q.push({start_i, start_j});
    was[start_i][start_j] = true;

    while (!q.empty()) {
      int i = q.front().first;
      int j = q.front().second;

      ans += height - initial_height[i][j];

      q.pop();

      for (int k = 0; k < 4; k++) {
        int x = i + dx[k];
        int y = j + dy[k];
        if (inside(x, y) && !was[x][y] && initial_height[x][y] <= height) {
          was[x][y] = true;
          q.push({x, y});
        }
      }
    }
  }

  cout << ans;

  return 0;
}
