#include <iostream>
#include <vector>

using namespace std;

int n, m;
const int MAXN = 2000;
int a[MAXN][MAXN];
bool used[MAXN][MAXN];
int dx[] = {0, 0, -1, 1};
int dy[] = {-1, 1, 0, 0};

bool ok;
int sz;

void dfs(int x, int y) {
    used[x][y] = true;
    sz++;
    for (int d = 0; d < 4; d++) {
        int xx = x + dx[d], yy = y + dy[d];
        if (xx < 0 || xx >= n || yy < 0 || yy >= m) {
            ok = false;
        } else if (!used[xx][yy] && a[xx][yy] == 1) {
            dfs(xx, yy);
        }
    }
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }

    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == 1 && !used[i][j]) {
                ok = true;
                sz = 0;
                dfs(i, j);
                if (ok) {
                    ans += sz;
                }
            }
        }
    }

    cout << ans << endl;

    return 0;
}
