#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 2000;
int a[MAXN][MAXN];
int n, m;
int used[MAXN][MAXN];
int cr = 0;
int dx[] = {-1, 1, 0, 0};
int dy[] = {0, 0, -1, 1};

bool ok;
int sz;

void dfs(int x, int y, int mxv) {
    used[x][y] = cr;
    sz++;
    for (int d = 0; d < 4; d++) {
        int xx = x + dx[d], yy = y + dy[d];
        if (xx < 0 || xx >= n || yy < 0 || yy >= m) {
            ok = false;
        } else if (a[xx][yy] <= mxv && used[xx][yy] < cr) {
            dfs(xx, yy, mxv);
        }
    }
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    vector<int> hs;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            hs.push_back(a[i][j]);
        }
    }

    sort(hs.begin(), hs.end());
    hs.resize(unique(hs.begin(), hs.end()) - hs.begin());

    long long ans = 0;
    for (int i = 0; i + 1 < hs.size(); i++) {
        cr++;
        int cur = 0;
        for (int x = 0; x < n; x++) {
            for (int y = 0; y < m; y++) {
                if (a[x][y] <= hs[i] && used[x][y] < cr) {
                    ok = true;
                    sz = 0;
                    dfs(x, y, hs[i]);
                    if (ok) {
                        cur += sz;
                    }
                }
            }
        }
        ans += 1LL * cur * (hs[i + 1] - hs[i]);
    }

    cout << ans << endl;

    return 0;
}