#include <iostream>
#include <set>
#include <vector>

using namespace std;

const int INF = 2000000000;

int dx[] = {0, 0, -1, 1};
int dy[] = {-1, 1, 0, 0};

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }

    vector<vector<int>> dst(n, vector<int> (m, INF));
    for (int j = 0; j < m; j++) {
        dst[0][j] = a[0][j];
        dst[n - 1][j] = a[n - 1][j];
    }
    for (int i = 0; i < n; i++) {
        dst[i][0] = a[i][0];
        dst[i][m - 1] = a[i][m - 1];
    }

    set<pair<int, pair<int, int>>> st;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            st.insert({dst[i][j], {i, j}});
        }
    }

    while (!st.empty()) {
        auto u = *st.begin();
        st.erase(st.begin());
        int x = u.second.first, y = u.second.second;
        for (int d = 0; d < 4; d++) {
            int xx = x + dx[d];
            int yy = y + dy[d];
            if (0 <= xx && xx < n && 0 <= yy && yy < m) {
                int w = max(dst[x][y], a[xx][yy]);
                if (w < dst[xx][yy]) {
                    st.erase({dst[xx][yy], {xx, yy}});
                    dst[xx][yy] = w;
                    st.insert({dst[xx][yy], {xx, yy}});
                }
            }
        }
    }

    long long ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            ans += dst[i][j] - a[i][j];
        }
    }

    cout << ans << endl;

    return 0;
}
