#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 2000;
int n, m;
int h[MAXN][MAXN];
int cr = 0;
int used[MAXN][MAXN];
int dx[] = {-1, 1, 0, 0};
int dy[] = {0, 0, -1, 1};

bool dfs(int x, int y, int v) {
    used[x][y] = cr;
    for (int d = 0; d < 4; d++) {
        int xx = x + dx[d], yy = y + dy[d];
        if (xx < 0 || xx >= n || yy < 0 || yy >= m) {
            return true;
        }
    }

    for (int d = 0; d < 4; d++) {
        int xx = x + dx[d], yy = y + dy[d];
        if (h[xx][yy] < v && used[xx][yy] < cr) {
            if (dfs(xx, yy, v)) {
                return true;
            }
        }
    }

    return false;
}

bool check(int x, int y, int v) {
    cr++;
    return !dfs(x, y, v);
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    int mx = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> h[i][j];
            mx = max(mx, h[i][j]);
        }
    }

    long long ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int L = 0;
            int R = mx + 1;
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (check(i, j, M)) {
                    L = M;
                } else {
                    R = M;
                }
            }

            ans += max(0, L - h[i][j]);
        }
    }

    cout << ans << endl;

    return 0;
}